searchNodes=[{"doc":"Sqlcx gives you a way to create and query SQLCipher (encrypted SQLite) databases.Basic Exampleiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.exec(db, &quot;CREATE TABLE t (a INTEGER, b INTEGER, c INTEGER)&quot;) :ok iex&gt; Sqlcx.exec(db, &quot;INSERT INTO t VALUES (1, 2, 3)&quot;) :ok iex&gt; Sqlcx.query(db, &quot;SELECT * FROM t&quot;) {:ok, [[a: 1, b: 2, c: 3]]} iex&gt; Sqlcx.query(db, &quot;SELECT * FROM t&quot;, into: %{}) {:ok, [%{a: 1, b: 2, c: 3}]} ConfigurationSqlcx uses the Erlang library esqlcipher which accepts a timeout parameter for almost all interactions with the database. The default value for this timeout is 5000 ms. Many functions in Sqlcx accept a :db_timeout option that is passed on to the esqlcipher calls and also defaults to 5000 ms. If required, this default value can be overridden globally with the following in your config.exs:config :sqlcx, db_timeout: 10_000 # or other positive integer number of msAnother esqlcipher parameter is :db_chunk_size. This is a count of rows to read from native sqlcipher and send to erlang process in one bulk. For example, consider a table mytable that has 1000 rows. We make the query to get all rows with db_chunk_size: 500 parameter:Sqlcx.query(db, &quot;select * from mytable&quot;, db_chunk_size: 500)in this case all rows will be passed from native sqlcipher OS thread to the erlang process in two passes. Each pass will contain 500 rows. This parameter decrease overhead of transmitting rows from native OS sqlcipher thread to the erlang process by chunking list of result rows. Please, decrease this value if rows are heavy. Default value is 5000. If you’re in doubt what to do with this parameter, just leave it as is. The default value will be ok in almost all cases.config :sqlcx, db_chunk_size: 500 # if most of the database rows are heavy","ref":"Sqlcx.html","title":"Sqlcx","type":"module"},{"doc":"","ref":"Sqlcx.html#close/2","title":"Sqlcx.close/2","type":"function"},{"doc":"Create a new table name where table_opts is a list of table constraints and cols is a keyword list of columns. The following table constraints are supported: :temp and :primary_key. Example:[:temp, {:primary_key, [:id]}]Columns can be passed as:name: :typename: {:type, constraints}where constraints is a list of column constraints. The following column constraints are supported: :primary_key, :not_null and :autoincrement. Example:id: :integer, name: {:text, [:not_null]}","ref":"Sqlcx.html#create_table/5","title":"Sqlcx.create_table/5","type":"function"},{"doc":"Send a raw SQL statement to the databaseThis function is intended for running fully-complete SQL statements. No query preparation, or binding of values takes place. This is generally useful for things like re-playing a SQL export back into the database.","ref":"Sqlcx.html#exec/3","title":"Sqlcx.exec/3","type":"function"},{"doc":"","ref":"Sqlcx.html#is_encrypted/1","title":"Sqlcx.is_encrypted/1","type":"function"},{"doc":"","ref":"Sqlcx.html#open/2","title":"Sqlcx.open/2","type":"function"},{"doc":"","ref":"Sqlcx.html#open!/2","title":"Sqlcx.open!/2","type":"function"},{"doc":"A shortcut to Sqlcx.Query.query/3","ref":"Sqlcx.html#query/3","title":"Sqlcx.query/3","type":"function"},{"doc":"A shortcut to Sqlcx.Query.query!/3","ref":"Sqlcx.html#query!/3","title":"Sqlcx.query!/3","type":"function"},{"doc":"A shortcut to Sqlcx.Query.query_rows/3","ref":"Sqlcx.html#query_rows/3","title":"Sqlcx.query_rows/3","type":"function"},{"doc":"A shortcut to Sqlcx.Query.query_rows!/3","ref":"Sqlcx.html#query_rows!/3","title":"Sqlcx.query_rows!/3","type":"function"},{"doc":"","ref":"Sqlcx.html#rekey/3","title":"Sqlcx.rekey/3","type":"function"},{"doc":"","ref":"Sqlcx.html#rekey!/3","title":"Sqlcx.rekey!/3","type":"function"},{"doc":"Sets a PID to receive notifications about table updates.Messages will come in the shape of: {action, table, rowid}action -&gt; :insert | :update | :deletetable -&gt; charlist of the table name. Example: 'posts'rowid -&gt; internal immutable rowid index of the row. This is *NOT* the `id` or `primary key` of the row.See the official docs.","ref":"Sqlcx.html#set_update_hook/3","title":"Sqlcx.set_update_hook/3","type":"function"},{"doc":"","ref":"Sqlcx.html#with_db/3","title":"Sqlcx.with_db/3","type":"function"},{"doc":"Runs fun inside a transaction. If fun returns without raising an exception, the transaction will be commited via commit. Otherwise, rollback will be called. ## Examplesiex&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex&gt; Sqlcx.with_transaction(db, fn(db) -&gt; ...&gt; Sqlcx.exec(db, &quot;create table foo(id integer)&quot;) ...&gt; Sqlcx.exec(db, &quot;insert into foo (id) values(42)&quot;) ...&gt; end) iex&gt; Sqlcx.query(db, &quot;select * from foo&quot;) {:ok, [[{:id, 42}]]}","ref":"Sqlcx.html#with_transaction/3","title":"Sqlcx.with_transaction/3","type":"function"},{"doc":"","ref":"Sqlcx.html#t:connection/0","title":"Sqlcx.connection/0","type":"type"},{"doc":"","ref":"Sqlcx.html#t:sqlite_error/0","title":"Sqlcx.sqlite_error/0","type":"type"},{"doc":"","ref":"Sqlcx.html#t:string_or_charlist/0","title":"Sqlcx.string_or_charlist/0","type":"type"},{"doc":"Functions for running queries against a SQLCipher database.These query functions handle details such as preparing a statement, binding values, etc. If you need to deal with these details on your own, please take a look at the Sqlcx.Statement module.","ref":"Sqlcx.Query.html","title":"Sqlcx.Query","type":"module"},{"doc":"Runs a query and returns the results.Parametersdb - An SQLCipher database.sql - The query to run as a string.opts - Options to pass into the query. See below for details.Optionsbind - If your query has parameters in it, you should provide the options to bind as a list.into - The collection to put results into. This defaults to a list.db_timeout - The timeout (in ms) to apply to each of the underlying SQLCipher operations. Defaults to Application.get_env(:sqlcx, :db_timeout) or 5000 ms if not configured.db_chunk_size - The number of rows to read from native sqlite and send to erlang process in one bulk. Defaults to Application.get_env(:sqlcx, :db_chunk_size) or 5000 ms if not configured.Returns on success on failure.","ref":"Sqlcx.Query.html#query/3","title":"Sqlcx.Query.query/3","type":"function"},{"doc":"Same as query/3 but raises a Sqlcx.QueryError on error.Returns the results otherwise.","ref":"Sqlcx.Query.html#query!/3","title":"Sqlcx.Query.query!/3","type":"function"},{"doc":"Runs a query and returns the results as a list of rows each represented as a list of column values.Parametersdb - An SQLCipher database.sql - The query to run as a string.opts - Options to pass into the query. See below for details.Optionsbind - If your query has parameters in it, you should provide the options to bind as a list.db_timeout - The timeout (in ms) to apply to each of the underlying SQLCipher operations. Defaults to Application.get_env(:sqlcx, :db_timeout) or 5000 ms if not configured.db_chunk_size - The number of rows to read from native sqlite and send to erlang process in one bulk. Defaults to Application.get_env(:sqlcx, :db_chunk_size) or 5000 ms if not configured.Returns} on success on failure.","ref":"Sqlcx.Query.html#query_rows/3","title":"Sqlcx.Query.query_rows/3","type":"function"},{"doc":"Same as query_rows/3 but raises a Sqlcx.QueryError on error.Returns the results otherwise.","ref":"Sqlcx.Query.html#query_rows!/3","title":"Sqlcx.Query.query_rows!/3","type":"function"},{"doc":"","ref":"Sqlcx.Query.html#t:query_option/0","title":"Sqlcx.Query.query_option/0","type":"type"},{"doc":"Sqlcx.Server provides a GenServer to wrap an sqlcipher db. This makes it easy to share a SQLCipher database between multiple processes without worrying about concurrency issues. You can also register the process with a name so you can query by name later.Unsupervised Exampleiex&gt; {:ok, pid} = Sqlcx.Server.start_link(&quot;:memory:&quot;, [name: :example]) iex&gt; Sqlcx.Server.exec(pid, &quot;CREATE TABLE t (a INTEGER, b INTEGER)&quot;) :ok iex&gt; Sqlcx.Server.exec(pid, &quot;INSERT INTO t (a, b) VALUES (1, 1), (2, 2), (3, 3)&quot;) :ok iex&gt; Sqlcx.Server.query(pid, &quot;SELECT * FROM t WHERE b = 2&quot;) {:ok, [[a: 2, b: 2]]} iex&gt; Sqlcx.Server.query(:example, &quot;SELECT * FROM t ORDER BY a LIMIT 1&quot;, into: %{}) {:ok, [%{a: 1, b: 1}]} iex&gt; Sqlcx.Server.query_rows(:example, &quot;SELECT * FROM t ORDER BY a LIMIT 2&quot;) {:ok, %{rows: [[1, 1], [2, 2]], columns: [:a, :b], types: [:INTEGER, :INTEGER]}} iex&gt; Sqlcx.Server.prepare(:example, &quot;SELECT * FROM t&quot;) {:ok, %{columns: [:a, :b], types: [:INTEGER, :INTEGER]}} # Subsequent queries using this exact statement will now operate more efficiently # because this statement has been cached. iex&gt; Sqlcx.Server.prepare(:example, &quot;INVALID SQL&quot;) {:error, {:sqlite_error, &#39;near &quot;INVALID&quot;: syntax error&#39;}} iex&gt; Sqlcx.Server.stop(:example) :ok iex&gt; :timer.sleep(10) # wait for the process to exit asynchronously iex&gt; Process.alive?(pid) false Supervised Exampleimport Supervisor.Spec children = [ worker(Sqlcx.Server, [&quot;priv/my_db.db&quot;, [name: :my_db]) ] Supervisor.start_link(children, strategy: :one_for_one)","ref":"Sqlcx.Server.html","title":"Sqlcx.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Sqlcx.Server.html#child_spec/1","title":"Sqlcx.Server.child_spec/1","type":"function"},{"doc":"","ref":"Sqlcx.Server.html#create_table/4","title":"Sqlcx.Server.create_table/4","type":"function"},{"doc":"Same as Sqlcx.exec/3 but using the shared db connections saved in the GenServer state.Returns the results otherwise.","ref":"Sqlcx.Server.html#exec/3","title":"Sqlcx.Server.exec/3","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Sqlcx.Server.html#init/1","title":"Sqlcx.Server.init/1","type":"function"},{"doc":"Prepares a SQL statement for future use.This causes a call to sqlite3_prepare_v2 to be executed in the Server process. To protect the reference to the corresponding sqlite3_stmt struct from misuse in other processes, that reference is not passed back. Instead, prepared statements are cached in the Server process. If a subsequent call to query/3 or query_rows/3 is made with a matching SQL statement, the prepared statement is reused.Prepared statements are purged from the cache when the cache exceeds a preset limit (20 statements by default).Returns summary information about the prepared statement. {:ok, %{columns: [:column1_name, :column2_name,... ], types: [:column1_type, ...]}} on success or {:error, {:reason_code, 'SQLite message'}} if the statement could not be prepared.","ref":"Sqlcx.Server.html#prepare/3","title":"Sqlcx.Server.prepare/3","type":"function"},{"doc":"Same as Sqlcx.Query.query/3 but using the shared db connections saved in the GenServer state.Returns the results otherwise.","ref":"Sqlcx.Server.html#query/3","title":"Sqlcx.Server.query/3","type":"function"},{"doc":"Same as Sqlcx.Query.query_rows/3 but using the shared db connections saved in the GenServer state.Returns the results otherwise.","ref":"Sqlcx.Server.html#query_rows/3","title":"Sqlcx.Server.query_rows/3","type":"function"},{"doc":"Change the password used to encrypt the database.","ref":"Sqlcx.Server.html#rekey/3","title":"Sqlcx.Server.rekey/3","type":"function"},{"doc":"","ref":"Sqlcx.Server.html#set_update_hook/3","title":"Sqlcx.Server.set_update_hook/3","type":"function"},{"doc":"Starts a SQLCipher Server (GenServer) instance.In addition to the options that are typically provided to GenServer.start_link/3, you can also specify:stmt_cache_size: (positive_integer) to override the default limit (20) of statements that are cached when calling prepare/3.db_timeout: (positive_integer) to override :esqlcipher's default timeout of 5000 ms for interactions with the database. This can also be set in config.exs as config :sqlcx, db_timeout: 5_000.db_chunk_size: (positive_integer) to override :esqlcipher's default chunk_size of 5000 rows to read from native sqlite and send to erlang process in one bulk. This can also be set in config.exs as config :sqlcx, db_chunk_size: 5_000.","ref":"Sqlcx.Server.html#start_link/2","title":"Sqlcx.Server.start_link/2","type":"function"},{"doc":"","ref":"Sqlcx.Server.html#stop/1","title":"Sqlcx.Server.stop/1","type":"function"},{"doc":"Runs fun inside a transaction. If fun returns without raising an exception, the transaction will be commited via commit. Otherwise, rollback will be called. Be careful if fun might take a long time to run. The function is executed in the context of the server and therefore blocks other requests until it's finished. ## Examplesiex&gt; {:ok, server} = Sqlcx.Server.start_link(&quot;:memory:&quot;) iex&gt; Sqlcx.Server.with_transaction(server, fn(db) -&gt; ...&gt; Sqlcx.Server.exec(db, &quot;create table foo(id integer)&quot;) ...&gt; Sqlcx.Server.exec(db, &quot;insert into foo (id) values(42)&quot;) ...&gt; end) iex&gt; Sqlcx.Server.query(server, &quot;select * from foo&quot;) {:ok, [[{:id, 42}]]}","ref":"Sqlcx.Server.html#with_transaction/3","title":"Sqlcx.Server.with_transaction/3","type":"function"},{"doc":"Implements a least-recently used (LRU) cache for prepared SQLite statements.Caches a fixed number of prepared statements and purges the statements which were least-recently used when that limit is exceeded.","ref":"Sqlcx.Server.StatementCache.html","title":"Sqlcx.Server.StatementCache","type":"module"},{"doc":"Creates a new prepared statement cache.","ref":"Sqlcx.Server.StatementCache.html#new/2","title":"Sqlcx.Server.StatementCache.new/2","type":"function"},{"doc":"Given a statement cache and an SQL statement (string), returns a tuple containing the updated statement cache and a prepared SQL statement.If possible, reuses an existing prepared statement. If not, prepares the statement and adds it to the cache, possibly removing the least-recently used prepared statement if the designated cache size limit would be exceeded.Will return {:error, reason} if SQLite is unable to prepare the statement.","ref":"Sqlcx.Server.StatementCache.html#prepare/3","title":"Sqlcx.Server.StatementCache.prepare/3","type":"function"},{"doc":"This module contains functions for SQL creation. At the moment it is only used for CREATE TABLE statements.","ref":"Sqlcx.SqlBuilder.html","title":"Sqlcx.SqlBuilder","type":"module"},{"doc":"","ref":"Sqlcx.SqlBuilder.html#create_table/3","title":"Sqlcx.SqlBuilder.create_table/3","type":"function"},{"doc":"Provides an interface for working with SQLite prepared statements.Care should be taken when using prepared statements directly - they are not immutable objects like most things in Elixir. Sharing a statement between different processes can cause problems if the processes accidentally interleave operations on the statement. It's a good idea to create different statements per process, or to wrap the statements up in a GenServer to prevent interleaving operations.Exampleiex(2)&gt; {:ok, db} = Sqlcx.open(&quot;:memory:&quot;) iex(3)&gt; Sqlcx.query(db, &quot;CREATE TABLE data (id, name);&quot;) {:ok, []} iex(4)&gt; {:ok, statement} = Sqlcx.Statement.prepare(db, &quot;INSERT INTO data VALUES (?, ?);&quot;) iex(5)&gt; Sqlcx.Statement.bind_values(statement, [1, &quot;hello&quot;]) iex(6)&gt; Sqlcx.Statement.exec(statement) :ok iex(7)&gt; {:ok, statement} = Sqlcx.Statement.prepare(db, &quot;SELECT * FROM data;&quot;) iex(8)&gt; Sqlcx.Statement.fetch_all(statement, db_timeout: 1_000) {:ok, [[id: 1, name: &quot;hello&quot;]]} iex(9)&gt; Sqlcx.close(db) :ok RETURNING Clause SupportSQLite does not support the RETURNING extension to INSERT, DELETE, and UPDATE commands. (See https://www.postgresql.org/docs/9.6/static/sql-insert.html for a description of the Postgres implementation of this clause.)Ecto 2.0+ relies on being able to capture this information, so have invented our own implementation with the following syntax:;--RETURNING ON [INSERT | UPDATE | DELETE] &lt;table&gt;,&lt;col&gt;,&lt;col&gt;,...When the prepare/2 and prepare!/2 functions are given a query that contains the above returning clause, they separate this clause from the end of the query and store it separately in the Statement struct. Only the portion of the query preceding the returning clause is passed to SQLite's prepare function.Later, when such a statement struct is passed to fetch_all/3 or fetch_all!/3 the returning clause is parsed and the query is performed with the following additional logic:SAVEPOINT sp_&lt;random&gt;; CREATE TEMP TABLE temp.t_&lt;random&gt; (&lt;returning&gt;); CREATE TEMP TRIGGER tr_&lt;random&gt; AFTER UPDATE ON main.&lt;table&gt; BEGIN INSERT INTO t_&lt;random&gt; SELECT NEW.&lt;returning&gt;; END; UPDATE ...; -- whatever the original statement was DROP TRIGGER tr_&lt;random&gt;; SELECT &lt;returning&gt; FROM temp.t_&lt;random&gt;; DROP TABLE temp.t_&lt;random&gt;; RELEASE sp_&lt;random&gt;;A more detailed description of the motivations for making this change is here: https://github.com/jazzyb/sqlite_ecto/wiki/Sqlite.Ecto's-Pseudo-Returning-Clause","ref":"Sqlcx.Statement.html","title":"Sqlcx.Statement","type":"module"},{"doc":"Binds values to a Sqlcx.StatementParametersstatement - The statement to bind values into.values - A list of values to bind into the statement.Also accepts the following keyword options:db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env.Returns{:ok, statement} on successSee :esqlcipher.prepare for errors.Value transformationsSome values will be transformed before insertion into the database.nil - Converted to :undefinedtrue - Converted to 1false - Converted to 0datetime - Converted into a string. See datetime_to_string%Decimal - Converted into a number.","ref":"Sqlcx.Statement.html#bind_values/3","title":"Sqlcx.Statement.bind_values/3","type":"function"},{"doc":"Same as bind_values/3 but raises a Sqlcx.Statement.BindValuesError on error.Returns the statement otherwise.","ref":"Sqlcx.Statement.html#bind_values!/3","title":"Sqlcx.Statement.bind_values!/3","type":"function"},{"doc":"Runs a statement that returns no results.Should be called after the statement has been bound.Parametersstatement - The statement to run.Also accepts the following keyword options:db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env.Returns:ok{:error, error}","ref":"Sqlcx.Statement.html#exec/2","title":"Sqlcx.Statement.exec/2","type":"function"},{"doc":"Same as exec/2 but raises a Sqlcx.Statement.ExecError on error.Returns :ok otherwise.","ref":"Sqlcx.Statement.html#exec!/2","title":"Sqlcx.Statement.exec!/2","type":"function"},{"doc":"Fetches all rows using a statement.Should be called after the statement has been bound.Parametersstatement - The statement to run.Also accepts the following keyword options:db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env.db_chunk_size - The internal bulk size. Defaults to 5000, or the :db_chunk_size value in Application env.into - The collection to put the results into. Defaults to an empty list.Returns{:ok, results}{:error, error}","ref":"Sqlcx.Statement.html#fetch_all/2","title":"Sqlcx.Statement.fetch_all/2","type":"function"},{"doc":"Same as fetch_all/3 but raises a Sqlcx.Statement.FetchAllError on error.Returns the results otherwise.","ref":"Sqlcx.Statement.html#fetch_all!/2","title":"Sqlcx.Statement.fetch_all!/2","type":"function"},{"doc":"Prepare a Sqlcx.StatementParametersdb - The database to prepare the statement for.sql - The SQL of the statement to prepare.Also accepts the following keyword options:db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env.Returns{:ok, statement} on successSee :esqlcipher.prepare for errors.","ref":"Sqlcx.Statement.html#prepare/3","title":"Sqlcx.Statement.prepare/3","type":"function"},{"doc":"Same as prepare/3 but raises a Sqlcx.Statement.PrepareError on error.Returns a new statement otherwise.","ref":"Sqlcx.Statement.html#prepare!/3","title":"Sqlcx.Statement.prepare!/3","type":"function"},{"doc":"","ref":"Sqlcx.Statement.html#time_to_string/1","title":"Sqlcx.Statement.time_to_string/1","type":"function"},{"doc":"","ref":"Sqlcx.OpenError.html","title":"Sqlcx.OpenError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.OpenError.html#message/1","title":"Sqlcx.OpenError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.QueryError.html","title":"Sqlcx.QueryError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.QueryError.html#message/1","title":"Sqlcx.QueryError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.RekeyError.html","title":"Sqlcx.RekeyError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.RekeyError.html#message/1","title":"Sqlcx.RekeyError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.BindValuesError.html","title":"Sqlcx.Statement.BindValuesError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.BindValuesError.html#message/1","title":"Sqlcx.Statement.BindValuesError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.ExecError.html","title":"Sqlcx.Statement.ExecError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.ExecError.html#message/1","title":"Sqlcx.Statement.ExecError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.FetchAllError.html","title":"Sqlcx.Statement.FetchAllError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.FetchAllError.html#message/1","title":"Sqlcx.Statement.FetchAllError.message/1","type":"function"},{"doc":"","ref":"Sqlcx.Statement.PrepareError.html","title":"Sqlcx.Statement.PrepareError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sqlcx.Statement.PrepareError.html#message/1","title":"Sqlcx.Statement.PrepareError.message/1","type":"function"},{"doc":"Sqlcx (sqlcipher interface for Elixir)An Elixir wrapper around esqlcipher. The main aim here is to provide convenient usage of sqlcipher databases (encrypted SQLite).Important NoteThis is a fork of the 'regular' sqlite variant (sqlitex). It is not finished yet and lots of things might change later on. Proceed with care :)Updated to 1.0With the 1.0 release, we made just a single breaking change. Sqlcx.Query.query previously returned just the raw query results on success and {:error, reason} on failure. This has been bothering us for a while, so we changed it in 1.0 to return {:ok, results} on success and {:error, reason} on failure. This should make it easier to pattern match on. The Sqlcx.Query.query! function has kept its same functionality of returning bare results on success and raising an error on failure.UsageThe simple way to use Sqlcx is just to open a database and run a querySqlcx.with_db(&#39;test/fixtures/golfscores.sqlite3&#39;, fn(db) -&gt; Sqlcx.query(db, &quot;SELECT * FROM players ORDER BY id LIMIT 1&quot;) end) # =&gt; [[id: 1, name: &quot;Mikey&quot;, created_at: {{2012,10,14},{05,46,28}}, updated_at: {{2013,09,06},{22,29,36}}, type: nil]] Sqlcx.with_db(&#39;test/fixtures/golfscores.sqlite3&#39;, fn(db) -&gt; Sqlcx.query(db, &quot;SELECT * FROM players ORDER BY id LIMIT 1&quot;, into: %{}) end) # =&gt; [%{id: 1, name: &quot;Mikey&quot;, created_at: {{2012,10,14},{05,46,28}}, updated_at: {{2013,09,06},{22,29,36}}, type: nil}]Pass the bind option to bind parameterized queries.Sqlcx.with_db(&#39;test/fixtures/golfscores.sqlite3&#39;, fn(db) -&gt; Sqlcx.query( db, &quot;INSERT INTO players (name, created_at, updated_at) VALUES (?1, ?2, ?3, ?4)&quot;, bind: [&#39;Mikey&#39;, &#39;2012-10-14 05:46:28.318107&#39;, &#39;2013-09-06 22:29:36.610911&#39;] ) end) # =&gt; [[id: 1, name: &quot;Mikey&quot;, created_at: {{2012,10,14},{05,46,28}}, updated_at: {{2013,09,06},{22,29,36}}, type: nil]]If you want to keep the database open during the lifetime of your project you can use the Sqlcx.Server GenServer module.start_link takes an options [db_password: &quot;password&quot;] tuple; password can be nil.Here's a sample from a phoenix projects main supervisor definition.children = [ # Start the endpoint when the application starts worker(Golf.Endpoint, []), worker(Sqlcx.Server, [&quot;golf.db&quot;, [db_password: &quot;password&quot;, name: Gold.DB]]) ]Now that the GenServer is running you can make queries viaSqlcx.Server.query(Golf.DB, &quot;SELECT g.id, g.course_id, g.played_at, c.name AS course FROM games AS g INNER JOIN courses AS c ON g.course_id = c.id ORDER BY g.played_at DESC LIMIT 10&quot;)ConfigurationSqlcx uses the Erlang library esqlcipher which accepts a timeout parameter for almost all interactions with the database. The default value for this timeout is 5000 ms. Many functions in Sqlcx accept a :db_timeout option that is passed on to the esqlite calls and also defaults to 5000 ms. If required, this default value can be overridden globally with the following in your config.exs:config :sqlcx, db_timeout: 10_000 # or other positive integer number of msAnother esqlite parameter is :db_chunk_size. This is a count of rows to read from native sqlite and send to erlang process in one bulk. For example, consider a table mytable that has 1000 rows. We make the query to get all rows with db_chunk_size: 500 parameter:Sqlcx.query(db, &quot;select * from mytable&quot;, db_chunk_size: 500)in this case all rows will be passed from native sqlite OS thread to the erlang process in two passes. Each pass will contain 500 rows. This parameter decrease overhead of transmitting rows from native OS sqlite thread to the erlang process by chunking list of result rows. Please decrease this value if rows are heavy. Default value is 5000.If you’re in doubt what to do with this parameter, just leave it as is. The default value will be ok in almost all cases.config :sqlcx, db_chunk_size: 500 # if most of the database rows are heavyLooking for Ecto?An SQLCipher Ecto2 adapter is in the works but is not finished yet.","ref":"readme.html","title":"Sqlcx (sqlcipher interface for Elixir)","type":"extras"}]